-
Preface
- FAQ
-
Part I - Basics
- Basics Data Structure
- Basics Sorting
- Basics Algorithm
- Basics Misc
-
Part II - Coding
- String
-
Integer Array
-
Remove Element
-
Zero Sum Subarray
-
Subarray Sum K
-
Subarray Sum Closest
-
Recover Rotated Sorted Array
-
Product of Array Exclude Itself
-
Partition Array
-
First Missing Positive
-
2 Sum
-
3 Sum
-
3 Sum Closest
-
Remove Duplicates from Sorted Array
-
Remove Duplicates from Sorted Array II
-
Merge Sorted Array
-
Merge Sorted Array II
-
Median
-
Partition Array by Odd and Even
-
Kth Largest Element
-
Remove Element
-
Binary Search
-
First Position of Target
-
Search Insert Position
-
Search for a Range
-
First Bad Version
-
Search a 2D Matrix
-
Search a 2D Matrix II
-
Find Peak Element
-
Search in Rotated Sorted Array
-
Search in Rotated Sorted Array II
-
Find Minimum in Rotated Sorted Array
-
Find Minimum in Rotated Sorted Array II
-
Median of two Sorted Arrays
-
Sqrt x
-
Wood Cut
-
First Position of Target
-
Math and Bit Manipulation
-
Single Number
-
Single Number II
-
Single Number III
-
O1 Check Power of 2
-
Convert Integer A to Integer B
-
Factorial Trailing Zeroes
-
Unique Binary Search Trees
-
Update Bits
-
Fast Power
-
Hash Function
-
Happy Number
-
Count 1 in Binary
-
Fibonacci
-
A plus B Problem
-
Print Numbers by Recursion
-
Majority Number
-
Majority Number II
-
Majority Number III
-
Digit Counts
-
Ugly Number
-
Plus One
-
Palindrome Number
-
Task Scheduler
-
Single Number
-
Linked List
-
Remove Duplicates from Sorted List
-
Remove Duplicates from Sorted List II
-
Remove Duplicates from Unsorted List
-
Partition List
-
Add Two Numbers
-
Two Lists Sum Advanced
-
Remove Nth Node From End of List
-
Linked List Cycle
-
Linked List Cycle II
-
Reverse Linked List
-
Reverse Linked List II
-
Merge Two Sorted Lists
-
Merge k Sorted Lists
-
Reorder List
-
Copy List with Random Pointer
-
Sort List
-
Insertion Sort List
-
Palindrome Linked List
-
LRU Cache
-
Rotate List
-
Swap Nodes in Pairs
-
Remove Linked List Elements
-
Remove Duplicates from Sorted List
-
Binary Tree
-
Binary Tree Preorder Traversal
-
Binary Tree Inorder Traversal
-
Binary Tree Postorder Traversal
-
Binary Tree Level Order Traversal
-
Binary Tree Level Order Traversal II
-
Maximum Depth of Binary Tree
-
Balanced Binary Tree
-
Binary Tree Maximum Path Sum
-
Lowest Common Ancestor
-
Invert Binary Tree
-
Diameter of a Binary Tree
-
Construct Binary Tree from Preorder and Inorder Traversal
-
Construct Binary Tree from Inorder and Postorder Traversal
-
Subtree
-
Binary Tree Zigzag Level Order Traversal
-
Binary Tree Serialization
-
Binary Tree Preorder Traversal
- Binary Search Tree
- Exhaustive Search
-
Dynamic Programming
-
Triangle
-
Backpack
-
Backpack II
-
Minimum Path Sum
-
Unique Paths
-
Unique Paths II
-
Climbing Stairs
-
Jump Game
-
Word Break
-
Longest Increasing Subsequence
-
Palindrome Partitioning II
-
Longest Common Subsequence
-
Edit Distance
-
Jump Game II
-
Best Time to Buy and Sell Stock
-
Best Time to Buy and Sell Stock II
-
Best Time to Buy and Sell Stock III
-
Best Time to Buy and Sell Stock IV
-
Distinct Subsequences
-
Interleaving String
-
Maximum Subarray
-
Maximum Subarray II
-
Longest Increasing Continuous subsequence
-
Longest Increasing Continuous subsequence II
-
Maximal Square
-
Triangle
- Graph
- Data Structure
- Big Data
- Problem Misc
-
Part III - Contest
- Google APAC
- Microsoft
- Appendix I Interview and Resume
-
Tags
Search a 2D Matrix
Question
- leetcode: Search a 2D Matrix | LeetCode OJ
- lintcode: (28) Search a 2D Matrix
Problem Statement
Write an efficient algorithm that searches for a value in an m x n matrix.
This matrix has the following properties:
- Integers in each row are sorted from left to right.
- The first integer of each row is greater than the last integer of the previous row.
Example
Consider the following matrix:
[
[1, 3, 5, 7],
[10, 11, 16, 20],
[23, 30, 34, 50]
]
copy
Given target = 3
, return true
.
Challenge
O(log(n) + log(m)) time
题解 - 一次二分搜索 V.S. 两次二分搜索
- 一次二分搜索 - 由于矩阵按升序排列,因此可将二维矩阵转换为一维问题。对原始的二分搜索进行适当改变即可(求行和列)。时间复杂度为
- 两次二分搜索 - 先按行再按列进行搜索,即两次二分搜索。时间复杂度相同。
一次二分搜索
Python
class Solution:
def search_matrix(self, matrix, target):
# Find the first position of target
if not matrix or not matrix[0]:
return False
m, n = len(matrix), len(matrix[0])
st, ed = 0, m * n - 1
while st + 1 < ed:
mid = (st + ed) / 2
if matrix[mid / n][mid % n] == target:
return True
elif matrix[mid / n][mid % n] < target:
st = mid
else:
ed = mid
return matrix[st / n][st % n] == target or \
matrix[ed / n][ed % n] == target
copy
C++
class Solution {
public:
bool searchMatrix(vector<vector<int>>& matrix, int target) {
if (matrix.empty() || matrix[0].empty()) return false;
int ROW = matrix.size(), COL = matrix[0].size();
int lb = -1, ub = ROW * COL;
while (lb + 1 < ub) {
int mid = lb + (ub - lb) / 2;
if (matrix[mid / COL][mid % COL] < target) {
lb = mid;
} else {
if (matrix[mid / COL][mid % COL] == target) return true;
ub = mid;
}
}
return false;
}
};
copy
Java
lower bound 二分模板。
public class Solution {
/**
* @param matrix, a list of lists of integers
* @param target, an integer
* @return a boolean, indicate whether matrix contains target
*/
public boolean searchMatrix(int[][] matrix, int target) {
if (matrix == null || matrix.length == 0 || matrix[0] == null) {
return false;
}
int ROW = matrix.length, COL = matrix[0].length;
int lb = -1, ub = ROW * COL;
while (lb + 1 < ub) {
int mid = lb + (ub - lb) / 2;
if (matrix[mid / COL][mid % COL] < target) {
lb = mid;
} else {
if (matrix[mid / COL][mid % COL] == target) {
return true;
}
ub = mid;
}
}
return false;
}
}
copy
源码分析
仍然可以使用经典的二分搜索模板(lower bound),注意下标的赋值即可。
- 首先对输入做异常处理,不仅要考虑到matrix为null,还要考虑到matrix[0]的长度也为0。
- 由于 lb 的变化处一定小于 target, 故在 else 中判断。
复杂度分析
二分搜索,.
两次二分法
Python
class Solution:
def search_matrix(self, matrix, target):
if not matrix or not matrix[0]:
return False
# first pos >= target
st, ed = 0, len(matrix) - 1
while st + 1 < ed:
mid = (st + ed) / 2
if matrix[mid][-1] == target:
st = mid
elif matrix[mid][-1] < target:
st = mid
else:
ed = mid
if matrix[st][-1] >= target:
row = matrix[st]
elif matrix[ed][-1] >= target:
row = matrix[ed]
else:
return False
# binary search in row
st, ed = 0, len(row) - 1
while st + 1 < ed:
mid = (st + ed) / 2
if row[mid] == target:
return True
elif row[mid] < target:
st = mid
else:
ed = mid
return row[st] == target or row[ed] == target
copy
源码分析
- 先找到
first position
的行, 这一行的最后一个元素大于等于target - 再在这一行中找target
复杂度分析
二分搜索,